<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_RESTO_BD)):
		$HEADER_CLASS_RESTO_BD=1;

	// La base de donnes
	require "class_bd.php3";
	require "class_commentairebd.php3";

	// Une classe resto pour grer les restos avec leurs infos associes
	class restoBd extends bd {

		// Constructeur
		function restoBd()
		{
			$this->bd();
		}

		// Liste des restos en attente
		function GetRestosEnAttente()
		{
			return $this->execute('select * from restos_en_attente order by date_entree');
		}

		function GetRestoResult()
		{
			$resto = $this->get_next_row();
			
			// Rcupration des avis associs
			$cb				= new commentaireBd();
			$resto['avis']	= $cb->GetListeAvisSurResto($resto['id']);

			return $resto;
		}

		// Combien de restos dans la base ?
		function GetRestos($where = 'prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			return $this->execute("select * from $table");
		}

		// Les restos incomplet
		function GetRestosIncomplet($field)
		{
			// Restos dont le champ choisi est vide
			return $this->execute("select * from restos where $field='' order by nom");
		}

		// Les restos ajouts ce jour 
		function GetRestosDuJour()
		{
			// Ajourd'hui, nous sommes le ...
			$aujourdhui	= date("Y-m-d");

			return $this->execute("select * from restos where to_days(date_entree) = to_days(\"$aujourdhui\") order by nom");
		}

		// Les restos ajouts ce mois 
		function GetRestosDuMois()
		{
			// Ce mois ci
			$cejourla	= date("d");
			$cemoisci	= date("m");
			$cetteannee	= date("Y");

			return $this->execute("select * from restos where month(date_entree) = $cemoisci and year(date_entree) = $cetteannee and dayofmonth(date_entree) <> $cejourla order by date_entree desc, nom");
		}

		// Liste des rgions comportant un ou plusieurs restos
		function GetRegions()
		{
			$nb = $this->execute('select region from restos group by region');
			for ($i=0; $i<$nb; $i++)
			{
				$tmp = $this->get_next_row();
				$result[$tmp['region']] = 1;
			}
			return $result;
		}

		// Liste des identifiants de restos classs
		// par ordre alphabtique
		function GetRestosParRegion($region = 0)
		{
			$requete	= 'select * from restos ';
			if ($region)
				$requete	.= "where region = $region ";
			$requete	.= 'order by region, nom';
			return $this->execute($requete);
		}

		// recherche de restos suivant un critre et un type
		function SearchRestos($critere, $val1, $val2="", $val3="", $val4="")
		{
			// On se mfie des caractres bizarres
			$val1	= addSlashes($val1);
			$val2	= addSlashes($val2);

			// Requete SQL de recherche de resto
			$requete	= "select distinct restos.id, restos.date_entree, nom, "
						. "adresse, region, metro, telephone, genre, "
						. "taille, ambiance, horaires, prix, ville, "
						. "pays from restos";

			switch ($critere)
			{
				case 'par_nom':
					$requete .= " where nom like '%$val1%' order by nom";
					break;

				case 'par_gourmet':
					$requete .= ", comments where pseudo like '%$val1%' and restos.id = comments.resto_id order by nom";
					break;

				case 'par_date_debut':
					$requete .= " where date_entree > '$val1' order by date_entree, nom";
					break;

				case 'par_periode':
					$requete .= " where date_entree > '$val1' and date_entree < '$val2' order by date_entree, nom";
					break;

				case 'par_mot_du_commentaire':
					$requete .= ", comments where commentaire like '%$val1%' and restos.id = comments.resto_id order by nom";
					break;

				case 'par_multi':
					$requete .= " where";
					// region
					if ($val1 != -1)
					{ $crit++; $requete .= " region = $val1"; }
					// taille
					if ($val2 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " taille = $val2"; $crit++; }
					// ambiance
					if ($val3 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " ambiance = $val3"; $crit++; }
					// prix
					if ($val4 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " prix = $val4"; $crit++; }
					break;
			}

			return $this->execute($requete);
		}

		// Rcupre un resto par son identifiant
		function GetRestoById($id, $where='prod')
		{
			// Choisit la table de recherche
			if ($where == 'prod')
					$table = 'restos';
			else	$table = 'restos_en_attente';

			// Requete SQL
			$nb = $this->execute("select * from $table where id = $id");
			if ($nb != 1)
				return false;
			return $this->get_next_row();
		}

		// Ajouter un resto dans la liste 
		function AddResto($resto, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			// Trouver un identifiant ok
			$this->execute("select max(id) from $table");
			$tmp	= $this->get_next_row();
			$id		= $tmp['max(id)'] + 1;

			// Prparer la requ^ete
			$query	= "insert into $table ";
			$query	.= '(id, date_entree, nom, adresse, region, metro, telephone, genre, taille, ambiance, horaires, prix, ville, pays) ';

			// On l'instancie
			$values	= sprintf('values (%d, %s, "%s", "%s", %d, "%s", "%s", "%s", %d, %d, "%s", %d, "%s", "%s")', 
							$id, 
							$resto['date_entree'], $resto['nom'],
							$resto['adresse'], $resto['region'],
							$resto['metro'], $resto['telephone'],
							$resto['genre'], $resto['taille'],
							$resto['ambiance'], $resto['horaires'],
							$resto['prix'],
							$resto['ville'], $resto['pays']);
			$query .= $values;

			// Enfin, on l'execute...
			$this->execute($query);
			return $id;
		}

		function DeleteResto($id, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			$this->execute("delete from $table where id = $id");
		}

		function BindImage($id, $image)
		{
			$this->execute("update restos set image='$image' where id=$id");
		}

		function UpdateField($id, $field, $value)
		{
			$this->execute("update restos set $field='$value' where id=$id");
		}
	}

	endif; // isset()
?>
