<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_COMMENTAIRE)):
		$HEADER_CLASS_COMMENTAIRE=1;

	require "const_resto.php3";
	require "class_data.php3";

	class Commentaire extends DataObject {

		// Constructeur
		function Commentaire($data = "")
		{
			$fields = array('id', 'date_entree', 'pseudo', 'resto_id',
							'e_mail', 'prive', 'commentaire', 'avis');

			if ($data == "")
					$this->DataObject($fields);
			else	$this->DataObject($data, 'assoc');
		}

		// vrifie les infos et renvoie un boolen indiquant
		// la validit des infos
		function infosOk()
		{
			$NOM_VALIDE		= '[a-zA-Z0-9_-]{1,}(\.[a-zA-Z0-9_-]){0,}';
			$DOMAINE_VALIDE	= '[a-zA-Z0-9_-]{1,}(\.[a-zA-Z0-9_-]){1,}';
			$ADRESSE_VALIDE = $NOM_VALIDE . '@' . $DOMAINE_VALIDE;

			$this->err	= "";
			$this->warn	= "";
			$ok			= true;

			if ($this->get('pseudo') == "")
			{ $ok=false; $this->err[] = "Vous avez oubli votre nom (ou pseudo) !"; }
			if ($this->get('e_mail') == "")
			{ $this->warn[] = "Vous n'avez pas indiqu d'adresse e-mail..."; }
			elseif (!ereg("$ADRESSE_VALIDE", $this->get('e_mail')))
			{ $this->warn[] = "Votre adresse e-mail a l'air bizarre..."; }
			if ($this->get('commentaire') == "")
			{ $ok=false; $this->err[] = "Vous avez oubli de donner votre commentaire !"; }

			return $ok;
		}

		function printDetail()
		{
			global $iconeAvis, $commentaireAvis;

			// Le drapeau donnant l'avis
			echo img($iconeAvis[$this->get('avis')],
					 $commentaireAvis[$this->get('avis')], "align=\"bottom\"");
			// Le commentaire
			echo "<i>", $this->get('commentaire'), "</i><br>\n";
			// Le pseudo
			echo "<b>", $this->get('pseudo'), "</b>";
			// et l'e-mail (si prcis et autoris)
			if (($this->get('prive') == 0) && ($this->get('e_mail') != ""))
				echo " <i>", $this->get('e_mail'), "</i>\n"; 
			// La date du commentaire
			if ($this->get('date_entree') != "")
				echo ", ", dateToFr($this->get('date_entree'));
		}
	}

	endif;	// isset()
?>
