<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_DATA)):
		$HEADER_CLASS_DATA=1;

	require "lib_misc.php3";

	// Une classe de donnes
	class DataObject {

		var	$obj;	// le tableau associatif
		var	$err;	// la liste d'erreur suite  vrification
		var $warn;	// la liste de warnings suite  vrification

		// Constructeur
		// l'objet s'initialise d'aprs une liste de variables
		// globales dont le nom est pass en paramtre
		// (si $init == global)
		// ou avec un tableau associatif contenant clefs et valeurs...
		function DataObject($fields, $init='global')
		{
			if ($init == 'global')
			{
				for ($i=0; $i<count($fields); $i++)
				{
					// On rcupre la valeur de la variable globale
					// correspondante en virant espaces avant et aprs
					$val	= trim($GLOBALS[$fields[$i]]);

					// On vire les caractres spciaux sous forme HTML
					// s'il y en a
					$val	= striphtmlspecialchars($val);
					// et les \' (bug chez free)
					$val	= stripslashes($val);

					$this->set($fields[$i], $val);
				}
			}
			else
			{
				reset($fields);
				while (list($k, $v) = each($fields))
				{
					// Pour virer les \' (bug free)
					$val	= stripslashes($v);

					$this->set($k, $val);
				}
			}
			$this->err	= "";
			$this->warn	= "";
		}

		function get($field_name)
		{ return $this->obj[$field_name]; }

		function set($field_name, $value)
		{ $this->obj[$field_name] = $value; }

		function exists($field_name)
		{ return in_array($field_name, array_keys($this->obj)); }

		function errors()
		{ return $this->err; }

		function warnings()
		{ return $this->warn; }

		function hidden()
		{
			reset($this->obj);
			while (list($k, $v) = each($this->obj))
			{
				// On ne met pas les clefs numriques
				// (elles sont redondantes)
				if (is_int($k))
					continue;

				// on vire les retours  la ligne pour viter des
				// problmes HTML
				$v	= str_replace("\n", " ", $v);
				$v	= str_replace("\r", " ", $v);

				// et on remplace les caractres gnants ", <, >, ...
				// par des entits HTML
				$v	= htmlspecialchars($v);

				$html .= "<input type=hidden name=\"$k\" value=\"$v\">\n";
			}
			return $html;
		}

		function data()
		{ return $this->obj; }

		function param()
		{
			reset($this->obj);
			while(list($k, $v) = each($this->obj))
				if (!is_int($k))
					$params[] = "$k=" . urlencode($v);
			return implode("&", $params);
		}
	}

	endif;
?>
